UNGETWC(3)

NAME
ungetwc, ungetwc_l - un-get wide character from input stream

LIBRARY
libc

SYNOPSIS
#include <stdio.h>
#include <wchar.h>
wint_t
ungetwc(wint_t wc, FILE *stream);
#include <stdio.h>
#include <wchar.h>
#include <xlocale.h>
wint_t
ungetwc_l(wint_t wc, FILE *stream, locale_t loc);

DESCRIPTION
The ungetwc() function pushes the wide character wc (converted to an wchar_t) back onto the input stream pointed to by stream. The pushed-backed wide characters will be returned (in reverse order) by subsequent reads on the stream. A successful intervening call to one of the file positioning functions fseek(3), fsetpos(3), or rewind(3), using the same stream, will discard the pushed-back wide characters.

Only one wide character of push-back is guaranteed, but as long as there is sufficient memory, an effectively infinite amount of push-back is allowed.

If a character is successfully pushed-back, the end-of-file indicator for the stream is cleared.

Although the ungetwc() function uses the current locale, the ungetwc_l() function may be passed a locale directly. See xlocale(3) for more information.

RETURN VALUES
The ungetwc() function returns the wide character pushed-back after the conversion, or WEOF if the operation fails. If the value of the argument c character equals WEOF, the operation will fail and the stream will remain unchanged.

SEE ALSO
fseek(3), getwc(3), xlocale(3)

STANDARDS
The ungetwc() function conforms to isoC-99.